$title (iDCM 44 Communications Firmware: Serial Handler Module)
$date (8 August 86)
$nomo
$paging
$registerbank (0)

;***************************************************************************
;*
;*     TITLE:          iDCM 44 Communications Firmware: Serial Handler Module
;*
;*     RELEASE:        2.0
;*
;*     DESCRIPTION:    This module contains the serial procedures
;*
;*     UPDATES:
;*
;***************************************************************************

;*         

;*           COPYRIGHT 1983, 1986 INTEL CORPORATION

;*

;*           INTEL CORPORATION PROPRIETARY INFORMATION.  THIS LISTING

;*           IS SUPPLIED UNDER THE TERMS OF A LICENSE  AGREEMENT WITH

;*           INTEL CORPORATION  AND MAY NOT  BE COPIED NOR  DISCLOSED

;*           EXCEPT IN  ACCORDANCE WITH THE  TERMS OF THAT AGREEMENT.

;* 

;***************************************************************************

name    dcm44s


using 0


$include(reg44.pdf)
$include(dcm44c.ext)
$include(dcm44c.lit)
$include(r2sys.mac)
$include(dcm44m.a51)


PUBLIC  init_serial, serial_interrupt_check, send_serial

PUBLIC  send_serial_slave_reply, initiate_order_transmission


PUBLIC  s_station_mode, s_timeout_set, s_timeout_count, s_init_mode

PUBLIC  s_info_mode, s_poll_mode, i_blocked_flag, x_parallel_enabled

PUBLIC  s_set_rts

PUBLIC  s_queue_ptr, s_station_state, s_station_poll, s_poll_queue_in

PUBLIC  s_poll_queue_out, s_last_nsnr, buf_size, s_timeout_val

EXTRN   CODE    (event_detect, serial_gateway_switch)
EXTRN   CODE    (auto_information_frame_check, check_receive_buffer)
EXTRN   CODE    (non_auto_master_rcv, non_auto_slave_rcv)

EXTRN   CODE    (swap_station_states)



EXTRN   DATA    (req_next_buffer, rqbufsize)


DCMFW_CODE_SEG          SEGMENT CODE
DCMFW_BIT_SEG           SEGMENT DATA    BITADDRESSABLE
DCMFW_INT_SEG           SEGMENT DATA

DCMFW_INT1_SEG          SEGMENT DATA
DCMFW_EXT_SEG           SEGMENT XDATA
DCMFW_STATION_SEG       SEGMENT XDATA   INPAGE
DCMFW_POLL_SEG          SEGMENT XDATA   INPAGE

RSEG                    DCMFW_BIT_SEG

s_station_ops:          ds      1

    s_station_mode      bit     s_station_ops.s_station_mode_bpos
    s_timeout_set       bit     s_station_ops.s_timeout_set_bpos
    s_timeout_count     bit     s_station_ops.s_timeout_count_bpos

    s_set_rts           bit     s_station_ops.s_timeout_count_bpos
    s_init_mode         bit     s_station_ops.s_init_mode_bpos
    s_info_mode         bit     s_station_ops.s_info_mode_bpos
    s_poll_mode         bit     s_station_ops.s_poll_mode_bpos
    i_blocked_flag      bit     s_station_ops.I_blocked_flag_bpos
    x_parallel_enabled  bit     s_station_ops.X_parallel_enabled_bpos


DSEG AT 2AH      



user_reserved:          ds      6     ;reserved 2ah - 2fh for user



RSEG                    DCMFW_INT_SEG

s_queue_ptr:            ds      1
s_poll_queue_in:        ds      1
s_poll_queue_out:       ds      1
s_last_nsnr:            ds      1

buf_size:               ds      1



RSEG                    DCMFW_INT1_SEG



s_timeout_val:          ds      1


RSEG                    DCMFW_STATION_SEG

s_station_state:        ds      256


RSEG                    DCMFW_POLL_SEG

s_station_poll:         ds      256

RSEG                    DCMFW_CODE_SEG

$EJECT
;***************************************************************************
;*
;*     PROCEDURE:      init_serial
;*
;*     PURPOSE:        Initialize SIU H/W and serial S/W
;*
;*     CALLED FROM:    comm_task
;*
;*     ENTERED FROM:   None
;*
;*     CALLS:          None
;*
;*     ENTERS:         None
;*
;*     INPUTS:         None
;*
;*     RETURNS:        Nothing
;*
;*     DESCRIPTION:    Init_Serial sets up the SIU for the configured
;*                     BITBUS attributes. If the timer is involved, it is
;*                     configured also.  It then initializes the serial

;*                     S/W data structures.

;*
;***************************************************************************

init_serial:
        mov     sts,#00000010b                ;init sts to am=1,rest=0

        mov     dptr, #g_station_mode_cfg     ;read the mode port      
        movx    a, @dptr
        anl     a, #bitbus_mode_msk           ;check the bitbus mode
        mov     dptr, #ish_bitbus_type_branch ;
        movc    a, @a+dptr
        jmp     @a+dptr                       ;jump to proper type

ish_bitbus_type_branch:
        db      ish_bitbus_ext_type - ish_bitbus_type_branch
        db      ish_bitbus_375K_type - ish_bitbus_type_branch
        db      ish_bitbus_187K_type - ish_bitbus_type_branch
        db      ish_bitbus_62K_type - ish_bitbus_type_branch

ish_bitbus_ext_type:
        mov     smd, #smd_bitbus_ext_msk        ;Set for External Bitbus mode
        sjmp    init_serial_sw                  ;Go initialize serial S/W

ish_bitbus_375K_type:
        mov     smd, #smd_bitbus_375k_msk       ;Otherwise set for 375K operation
        sjmp    init_serial_sw                  ;Go initialize serial S/W

ish_bitbus_187K_type:
        mov     smd, #smd_bitbus_187k_msk       ;Otherwise set for 187K operation
        sjmp    init_serial_sw                  ;Go initialize serial S/W

ish_bitbus_62K_type:
        mov     th1, #timer_count_msk           ;Set timer count for one (62.5K)

        mov     smd, #smd_bitbus_62k_msk        ;Set for 62K operation
        orl     tmod, #timer_mode_msk           ;Set timer mode
        setb    tr1                             ;Enable timer 1

init_serial_sw:

        clr     a

;       mov     s_queue_ptr, a                  ;clear message queue
        mov     s_station_ops, a                ;clear all mode flags
        mov     rbs, a                          ;
        mov     rbl, a                          ;
        mov     tbs, a
        mov     tbl, a

        mov     buf_size,rqbufsize              ;init buf_size variable

        dec     buf_size                        ;

        dec     buf_size                        ;

        mov     s_timeout_val,#bitbus_response_max ;init serial timeout val
        mov     dptr, #g_station_address_cfg
        movx    a, @dptr                        ;get the configured station address
        mov     stad, a                         ;  and set SIU receive address to it
        setb    rbe                             ;Turn on the SIU to receive
        ret                                     ;done

$EJECT
;***************************************************************************
;*
;*     ENTRY:          serial_interrupt_check
;*
;*     PURPOSE:        first stage decode of serial interrupt
;*
;*     ENTERED FROM:   event_detect
;*
;*     ENTERS:         auto_information_frame_check
;*                     non_auto_slave_rcv          

;*                     non_auto_master_rcv         
;*                     event_detect 
;*
;*     CALLS:          None
;*
;*     INPUTS:         None
;*
;*     RETURNS:        None
;*
;*     DESCRIPTION:    If this station is a slave:
;*                       If in auto mode, jump to auto routine.      
;*                       Else if no frame received, then

;*                               assume transmit ack.  set to auto mode
;*                               and wait on event.
;*                            else jump to slave non-auto rcv routine. 
;*                     If this station is a master:
;*                       If no frame received, then this was a xmit-complete

;*                          interrupt.  So set the serial timeout flag

;*                          and wait on the next event.

;*                       else clear the serial timeout flag and counter

;*                          and jump to the master receive frame routine.
;*
;***************************************************************************

serial_interrupt_check:
    clr     si                           ;clear interrupt flag

    jb      s_station_mode,master_int    ;if master, jump



; Process this interrupt as a non-master

;

    jnb     am, slave_non_auto           ;if slave in flex mode, jump
    ajmp    auto_information_frame_check ;else jump to auto frame check routine



slave_non_auto:

    jb      rbe, slave_xmit_ack          ;if no frame received, jump

    ajmp    non_auto_slave_rcv           ;else process received frame



slave_xmit_ack:

; The interrupt was caused by the completed transmission of a frame by the

; slave.  Set to auto mode.

;

    setb    am                           ;set to auto mode
    ajmp    event_detect                 ;go wait on event


master_int:

    jb      rbe, master_xmit_ack         ;if no receive buffer, then deal with
                                         ;transmit-complete interrupt

master_rcv_int:

; A frame was received by the master.  Go investigate the type of frame

; and process accordingly

;

    clr     si                           ;clear any extra interrupt

    clr     s_timeout_set                ;reset the timeout flag
    clr     s_timeout_count              ;zero the timeout count
    ajmp    non_auto_master_rcv          ;go process received frame



master_xmit_ack:

; Since rbe=1, it is assumed here that the interrupt was caused by

; a transmit-complete condition.

;

    setb    s_timeout_set                ;else set timeout for a response

    ajmp    event_detect                 ;go wait on next event


$EJECT
;***************************************************************************
;*
;*     PROCEDURE:      send_serial
;*
;*     PURPOSE:        initiate serial transmission of message
;*
;*     CALLED FROM:    None
;*
;*     ENTERED FROM:   local_gateway_switch
;*                     parallel_gateway_switch
;*
;*     CALLS:          enqueue_message
;*
;*     ENTERS:         serial_order_send (implicit)    (msg_ptr in R0)
;*                     serial_reply_send               (msg_ptr in R0)
;*
;*     INPUTS:         msg_ptr in R0
;*
;*     RETURNS:        None
;*
;*     DESCRIPTION:    Checks message type for order or reply, then
;*                     jumps to appropriate routine to send it.
;*
;***************************************************************************

send_serial:

; If the link is active (in init., poll, or info. mode), enqueue the message 

; and return.  Otherwise, enqueue the message and initiate transmission

;

        %enqueue_message_def(s_queue_ptr)   ;enqueue the message

        mov     a,#active_link_msk          ;in init, poll, or info mode?

        anl     a,s_station_ops             ;

        jnz     ret_vec                     ;if link active, return

        acall   check_receive_buffer        ;check on receive buffer

        jb      s_station_mode,initiate_order_transmission ;if master, jump 



; This station is not a master.  See if the message is an order or a 

; reply.  If an order, change the station into a master.

;

        %set_msg_ptr(message_route_ofs)     ;check msg type

        mov     a, @r1                      ;

        jnb     acc.msg_type_bpos, send_serial_slave_order ;if order, jump



send_serial_slave_reply:

; This public procedure sends a reply message serially from a slave.

; Inputs:  r0 = the address of the message to be sent

;

        setb    s_info_mode                 ;
        %set_msg_ptr(message_length_ofs)    ;r1,a => message.length
        mov     tbs, a                      ;Set new message pointer
        mov     tbl, @r1                    ;Set new message length
        dec     tbl                         ; 
        dec     tbl                         ; 
        setb    tbf                         ;Enable transmit

ret_vec:
        ret                                 ;Return to wherever this
                                            ; started


send_serial_slave_order:

; The slave is requested to send an order.  Set up for being a master and

; transmit the order message.

; Inputs: r0 => order message

;

        setb    s_station_mode              ;set to master mode

        clr     am                          ;clear auto mode

        mov     a, #ofl_msk                 ;a <= offline mask
        mov     nsnr, a                     ;set nsnr to offline

        mov     dptr, #s_station_state      ;initialize station state table

loop1:                                      ;to all entries offline
        movx    @dptr, a                    ;
        djnz    dpl, loop1                  ;



        mov     dptr, #s_station_poll       ;initialize station poll table

        clr     a                           ;to all zero entries

loop2:                                      ;

        movx    @dptr, a                    ;

        djnz    dpl, loop2                  ;

        mov     s_poll_queue_out, a         ;set poll queue ptr to zero

        mov     stad,#0ffh                  ;set station addr. to ff

 ;      sjmp    initiate_order_transmission ;transmit order as master



$EJECT
;***************************************************************************
;*
;*     PROCEDURE:      initiate_order_transmission
;*
;*     PURPOSE:        initiate_order_transmission starts the serial
;*                     transmission of an order message.

;*

;*     ENTERED BY:     send_serial
;*
;*     CALLED BY:      station_swap_check
;*
;*     CALLS:          None
;*
;*     INPUTS:         Message Pointer: r0
;*
;*     RETURNS:        Nothing
;*
;*     DESCRIPTION:    Checks for destination address match to current
;*                     station address (STAD).  If no match, then
;*                     the current NSNR is written to current station's
;*                     state (s_station_state), and the new station's
;*                     state is written to NSNR --- unless, the station
;*                     is currently unsynchronized.  Then the message is
;*                     pushed back into the queue and a DISC is sent to
;*                     initiate the synchronization handshake.
;*                     Otherwise, the transmit pointer and length are
;*                     set up, and an I frame generated with Nr and Ns
;*                     from NSNR.
;*
;***************************************************************************

initiate_order_transmission:

        %set_msg_ptr(message_station_ofs)   ;check the msg's station

        mov     a,@r1                       ;swap stations if needed
        acall   swap_station_states         ;input: a = msg.stad
        jb      ses, ios_station_init       ;if not yet intitialized, then start

        %set_msg_ptr(message_length_ofs)    ;else set up i-frame for xmit
        mov     tbs, r1                     ;
        mov     tbl, @r1                    ;
        dec     tbl                         ;
        dec     tbl                         ;
        mov     a, nsnr                     ;
        mov     s_last_nsnr, a              ;save current nsnr count
        swap    a                           ;build control byte
        orl     a, #i_msk                   ;
        mov     tcb, a                      ;
        setb    s_info_mode                 ;set to info mode

;       sjmp    ios_frame_transmit          ;



ios_frame_transmit:                         ;transmit frame

        mov     sts, #11100000B             ;rts=1, tbf=1, rbe=1

        ret                                 ;and return

ios_station_init:
        setb    s_init_mode                 ;set to initialization mode
        mov     tcb, #disc_msk              ;set to transmit DISC

        sjmp    ios_frame_transmit

END
